agents

## Class Environment

- java.lang.Object
- - agents.Environment

-     public class Environment
      extends java.lang.Object

  Version:
    1.0
  Author:
    Alan Mills

    This class implements the simulation's Environment. The Environment is the container for the model’s agents. It creates the simulation’s Employee agents, and maintains a list of them. It also reads data from external files, obtains and validates user-provided parameters, and schedules agent behaviors.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Environment(repast.simphony.space.continuous.ContinuousSpace<java.lang.Object> pWorkplaceSpace, repast.simphony.context.Context<java.lang.Object> pContext)` Constructs the Environment agent.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static double` | `getAbsenteeismDays()`
    `static double` | `getAverageAnnualDiabetesMedicalExpenditure()`
    `static int` | `getCurrentMaximumEmployeeIDNumber()`
    `static java.lang.String` | `getDataWorkbookFileName()`
    `static double` | `getDiabetesIncidenceAdjustmentFactor()`
    `static double[][]` | `getDiabetesIncidenceRate()`
    `static java.lang.String` | `getDiabetesIncidenceWorksheetName()`
    `static double` | `getDiabetesPrevalenceAdjustmentFactor()`
    `static double[][]` | `getDiabetesPrevalenceRate()`
    `static java.lang.String` | `getDiabetesPrevalenceWorksheetName()`
    `static double` | `getDiabetesRemissionAdjustmentFactor()`
    `static double[][]` | `getDiabetesRemissionRate()`
    `static java.lang.String` | `getDiabetesRemissionWorksheetName()`
    `static java.lang.String` | `getEmployeeAgeDistributionType()`
    `static double` | `getEmployeeAgeStandardDeviation()`
    `static int` | `getEmployeeAverageAge()`
    `static double` | `getEmployeeFirstGoalPercent_Conformance()`
    `static double` | `getEmployeeFirstGoalPercent_Health()`
    `static double` | `getEmployeeFirstGoalPercent_Income()`
    `static java.lang.String` | `getEmployeeLabels()`
    `static java.util.ArrayList<Employee>` | `getEmployeeList()`
    `static double` | `getEmployeesNormalWeightPercent()`
    `static double` | `getEmployeesObesePercent()`
    `static double` | `getEmployeesOverweightPercent()`
    `static double` | `getEmployeeStageOfChange_NormalWeight_Stage1Percent()`
    `static double` | `getEmployeeStageOfChange_NormalWeight_Stage2Percent()`
    `static double` | `getEmployeeStageOfChange_NormalWeight_Stage3Percent()`
    `static double` | `getEmployeeStageOfChange_Obese_Stage1Percent()`
    `static double` | `getEmployeeStageOfChange_Obese_Stage2Percent()`
    `static double` | `getEmployeeStageOfChange_Obese_Stage3Percent()`
    `static double` | `getEmployeeStageOfChange_Overweight_Stage1Percent()`
    `static double` | `getEmployeeStageOfChange_Overweight_Stage2Percent()`
    `static double` | `getEmployeeStageOfChange_Overweight_Stage3Percent()`
    `static java.lang.String` | `getEmployeeWorkplaceLocationDistributionType()`
    `static double` | `getEmployeeWorkplaceLocationStandardDeviation()`
    `static double` | `getEmployeeWorkplaceNeighborhoodRadius()`
    `static int` | `getMaximumSimulationPeriods()`
    `static int` | `getNumberOfEmployees()`
    `static java.lang.String` | `getOutputFileName()`
    `static java.lang.String` | `getOverrideParameters()`
    `static double` | `getPresenteeismDays()`
    `static Constants.IntensityLevel` | `getProgramDesign_ChoiceArchitectureIntensity()`
    `static double` | `getProgramDesign_ChoiceArchitectureLevel1AnnualCost()`
    `static double` | `getProgramDesign_ChoiceArchitectureLevel2AnnualCost()`
    `static Constants.IntensityLevel` | `getProgramDesign_IncentiveIntensity()`
    `static double` | `getProgramDesign_IncentiveLevel1AnnualCost()`
    `static double` | `getProgramDesign_IncentiveLevel2AnnualCost()`
    `static java.lang.String` | `getProgramDesign_TargetGroup()`
    `static Constants.IntensityLevel` | `getProgramDesign_Type()`
    `static double` | `getProgramDesign_TypeLevel1AnnualCost()`
    `static double` | `getProgramDesign_TypeLevel2AnnualCost()`
    `static int` | `getRandomSeed()`
    `static int` | `getRetirementAge()`
    `static int` | `getRunNumber()`
    `static double` | `getTurnover_AdditionalProbability()`
    `static double` | `getTurnover_BaseProbability()`
    `static double` | `getWeightProgressionAdjustmentFactor()`
    `static double[][]` | `getWeightProgressionRate()`
    `static java.lang.String` | `getWeightProgressionWorksheetName()`
    `static double` | `getWeightRegressionAdjustmentFactor()`
    `static double[][]` | `getWeightRegressionRate()`
    `static java.lang.String` | `getWeightRegressionWorksheetName()`
    `static java.lang.String` | `getWriteOutputFile()`
    `void` | `i1_getInputParameters()`
    `void` | `p1_OverrideParameters()`
    `static void` | `p2_CreateEmployee(int pIndex, repast.simphony.context.Context<java.lang.Object> pContext)`
    `static void` | `setCurrentMaximumEmployeeIDNumber(int pCurrentMaximumEmployeeIDNumber)`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Environment

          public Environment(repast.simphony.space.continuous.ContinuousSpace<java.lang.Object> pWorkplaceSpace,
                     repast.simphony.context.Context<java.lang.Object> pContext)

      Constructs the Environment agent. The constructor obtains and validates input parameters, reads data from the Excel file, creates the Employee agents, creates a list of the Employee agents, and schedules Employee behaviors.
      Parameters:
        `pWorkplaceSpace` - The identifier for the "space" simulation environment
        `pContext` - The identifier for the simulation "context"
      Throws:
        `jxl.read.biff.BiffException`

  - ### Method Detail

    - #### i1_getInputParameters

          public void i1_getInputParameters()

    - #### p1_OverrideParameters

          public void p1_OverrideParameters()

    - #### p2_CreateEmployee

          public static void p2_CreateEmployee(int pIndex,
                               repast.simphony.context.Context<java.lang.Object> pContext)

    - #### getRunNumber

          public static int getRunNumber()

    - #### getEmployeeList

          public static java.util.ArrayList<Employee> getEmployeeList()

    - #### getEmployeeLabels

          public static java.lang.String getEmployeeLabels()

    - #### getMaximumSimulationPeriods

          public static int getMaximumSimulationPeriods()

    - #### getRandomSeed

          public static int getRandomSeed()

    - #### getProgramDesign_TargetGroup

          public static java.lang.String getProgramDesign_TargetGroup()

    - #### getProgramDesign_Type

          public static Constants.IntensityLevel getProgramDesign_Type()

    - #### getProgramDesign_TypeLevel1AnnualCost

          public static double getProgramDesign_TypeLevel1AnnualCost()

    - #### getProgramDesign_TypeLevel2AnnualCost

          public static double getProgramDesign_TypeLevel2AnnualCost()

    - #### getProgramDesign_ChoiceArchitectureIntensity

          public static Constants.IntensityLevel getProgramDesign_ChoiceArchitectureIntensity()

    - #### getProgramDesign_ChoiceArchitectureLevel1AnnualCost

          public static double getProgramDesign_ChoiceArchitectureLevel1AnnualCost()

    - #### getProgramDesign_ChoiceArchitectureLevel2AnnualCost

          public static double getProgramDesign_ChoiceArchitectureLevel2AnnualCost()

    - #### getProgramDesign_IncentiveIntensity

          public static Constants.IntensityLevel getProgramDesign_IncentiveIntensity()

    - #### getProgramDesign_IncentiveLevel1AnnualCost

          public static double getProgramDesign_IncentiveLevel1AnnualCost()

    - #### getProgramDesign_IncentiveLevel2AnnualCost

          public static double getProgramDesign_IncentiveLevel2AnnualCost()

    - #### getAverageAnnualDiabetesMedicalExpenditure

          public static double getAverageAnnualDiabetesMedicalExpenditure()

    - #### getNumberOfEmployees

          public static int getNumberOfEmployees()

    - #### getEmployeeAgeDistributionType

          public static java.lang.String getEmployeeAgeDistributionType()

    - #### getEmployeeAverageAge

          public static int getEmployeeAverageAge()

    - #### getEmployeeAgeStandardDeviation

          public static double getEmployeeAgeStandardDeviation()

    - #### getEmployeeWorkplaceLocationDistributionType

          public static java.lang.String getEmployeeWorkplaceLocationDistributionType()

    - #### getEmployeeWorkplaceLocationStandardDeviation

          public static double getEmployeeWorkplaceLocationStandardDeviation()

    - #### getEmployeeWorkplaceNeighborhoodRadius

          public static double getEmployeeWorkplaceNeighborhoodRadius()

    - #### getEmployeeFirstGoalPercent_Health

          public static double getEmployeeFirstGoalPercent_Health()

    - #### getEmployeeFirstGoalPercent_Conformance

          public static double getEmployeeFirstGoalPercent_Conformance()

    - #### getEmployeeFirstGoalPercent_Income

          public static double getEmployeeFirstGoalPercent_Income()

    - #### getEmployeesNormalWeightPercent

          public static double getEmployeesNormalWeightPercent()

    - #### getEmployeesOverweightPercent

          public static double getEmployeesOverweightPercent()

    - #### getEmployeesObesePercent

          public static double getEmployeesObesePercent()

    - #### getEmployeeStageOfChange_NormalWeight_Stage1Percent

          public static double getEmployeeStageOfChange_NormalWeight_Stage1Percent()

    - #### getEmployeeStageOfChange_NormalWeight_Stage2Percent

          public static double getEmployeeStageOfChange_NormalWeight_Stage2Percent()

    - #### getEmployeeStageOfChange_NormalWeight_Stage3Percent

          public static double getEmployeeStageOfChange_NormalWeight_Stage3Percent()

    - #### getEmployeeStageOfChange_Overweight_Stage1Percent

          public static double getEmployeeStageOfChange_Overweight_Stage1Percent()

    - #### getEmployeeStageOfChange_Overweight_Stage2Percent

          public static double getEmployeeStageOfChange_Overweight_Stage2Percent()

    - #### getEmployeeStageOfChange_Overweight_Stage3Percent

          public static double getEmployeeStageOfChange_Overweight_Stage3Percent()

    - #### getEmployeeStageOfChange_Obese_Stage1Percent

          public static double getEmployeeStageOfChange_Obese_Stage1Percent()

    - #### getEmployeeStageOfChange_Obese_Stage2Percent

          public static double getEmployeeStageOfChange_Obese_Stage2Percent()

    - #### getEmployeeStageOfChange_Obese_Stage3Percent

          public static double getEmployeeStageOfChange_Obese_Stage3Percent()

    - #### getTurnover_BaseProbability

          public static double getTurnover_BaseProbability()

    - #### getTurnover_AdditionalProbability

          public static double getTurnover_AdditionalProbability()

    - #### getRetirementAge

          public static int getRetirementAge()

    - #### getAbsenteeismDays

          public static double getAbsenteeismDays()

    - #### getPresenteeismDays

          public static double getPresenteeismDays()

    - #### getDataWorkbookFileName

          public static java.lang.String getDataWorkbookFileName()

    - #### getDiabetesIncidenceWorksheetName

          public static java.lang.String getDiabetesIncidenceWorksheetName()

    - #### getDiabetesIncidenceAdjustmentFactor

          public static double getDiabetesIncidenceAdjustmentFactor()

    - #### getDiabetesPrevalenceWorksheetName

          public static java.lang.String getDiabetesPrevalenceWorksheetName()

    - #### getDiabetesPrevalenceAdjustmentFactor

          public static double getDiabetesPrevalenceAdjustmentFactor()

    - #### getDiabetesRemissionWorksheetName

          public static java.lang.String getDiabetesRemissionWorksheetName()

    - #### getDiabetesRemissionAdjustmentFactor

          public static double getDiabetesRemissionAdjustmentFactor()

    - #### getWeightProgressionWorksheetName

          public static java.lang.String getWeightProgressionWorksheetName()

    - #### getWeightProgressionAdjustmentFactor

          public static double getWeightProgressionAdjustmentFactor()

    - #### getWeightRegressionWorksheetName

          public static java.lang.String getWeightRegressionWorksheetName()

    - #### getWeightRegressionAdjustmentFactor

          public static double getWeightRegressionAdjustmentFactor()

    - #### getOverrideParameters

          public static java.lang.String getOverrideParameters()

    - #### getWriteOutputFile

          public static java.lang.String getWriteOutputFile()

    - #### getOutputFileName

          public static java.lang.String getOutputFileName()

    - #### getDiabetesIncidenceRate

          public static double[][] getDiabetesIncidenceRate()

    - #### getDiabetesPrevalenceRate

          public static double[][] getDiabetesPrevalenceRate()

    - #### getDiabetesRemissionRate

          public static double[][] getDiabetesRemissionRate()

    - #### getWeightRegressionRate

          public static double[][] getWeightRegressionRate()

    - #### getWeightProgressionRate

          public static double[][] getWeightProgressionRate()

    - #### getCurrentMaximumEmployeeIDNumber

          public static int getCurrentMaximumEmployeeIDNumber()

    - #### setCurrentMaximumEmployeeIDNumber

          public static void setCurrentMaximumEmployeeIDNumber(int pCurrentMaximumEmployeeIDNumber)